// C Source File
// Created 4/16/01; 9:54:36 PM

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
#define NO_EXIT_SUPPORT
#define NO_AMS_CHECK
#define NO_CALC_DETECT
#define SAVE_SCREEN           // Save/Restore LCD Contents

#define USE_TI92PLUS
#define USE_TI89
#define USE_V200

#include <tigcclib.h>         // Include All Header Files
#include "Remote.h"

// Main Function
void _main(void)
{

		l_char t={0x09870000}; //a packed number that contains the info sent...
		int wpos=0;					//position to echo key strokes back to
		i_char y;						 //stores a keypress
		int lcdw=LCD_WIDTH;		 //guess
		int lcdh=LCD_HEIGHT;	//guess
		SCR_RECT rect={{0,36,lcdw,lcdh-8}};
    const int unsigned maxArgs=100;   //maximum of passable Arguments per run
  	int i=0; // Counter variable for for-loop. Only god knows why I can't declare that in the For-Statement...
		short signed cmdsToPass[maxArgs]; 
    for (i=0;i<=(signed)maxArgs;i++) {cmdsToPass[i]=0;} //initialise Array
    int cmdCount=-1; //attention! cmdCount=0 means there is one command to pass!
    char strArg[maxArgs];
    		
    ESI argptr;
	  int argtype;
	  InitArgPtr (argptr);


 // Decode command-line arguments, if there are any
 
	  while ((argtype = GetArgType(argptr)) != END_TAG)
	    {

        if (cmdCount>=(signed)maxArgs)
        {
         ERD_dialog(940,FALSE); // throw "too many Arguments" error
				 return;
        }
         
	      if (argtype == STR_TAG)
         {
					strcpy(strArg,GetStrnArg (argptr));
					for (i=0;i<(signed)strlen(strArg);i++)
					{
					 cmdCount++;
           cmdsToPass[cmdCount]=strArg[i];
					}
         }
         
	      else if (argtype == POSINT_TAG)
	        {
           cmdCount++;
           cmdsToPass[cmdCount]=GetIntArg (argptr);
	        }
	      else if (argtype == NEGINT_TAG)
	        {
           cmdCount++;
           cmdsToPass[cmdCount]=-(GetIntArg (argptr));
	        }
	      else
	        {
            ERD_dialog(210,FALSE); // throw "Data Type" error	         
	          break;
	        }
	    }		



	// print the Header (only interactive mode)
	
    if (cmdCount==-1) 
		{
			lcdw/=2;
			
			ClrScr();
			FontSetSys(F_8x10);
			DrawStr(lcdw-52,0," Remote v1.3 ",A_REVERSE);				
			FontSetSys(F_6x8);
			DrawStr(lcdw-27,11," By Greg ",A_REVERSE);
			DrawStr(lcdw-54,23,"PRESS <ON> to exit",A_NORMAL);
		}

  // initialize delay timer
  
		OSFreeTimer (USER_TIMER); 
	  OSRegisterTimer (USER_TIMER,1); // Prepare Timer for first loop
		
	
		for(i=0;i<=cmdCount|| cmdCount==-1;i++)
		{

		 OSLinkOpen();

		 if (cmdCount==-1) // interactive mode
		   {
		   	i--; // do an endless loop in interactive mode
		  	y.x=ngetchx();  //get a keypress
		   }
  	 else  // command-line mode
		  {
		 	 if (cmdsToPass[i]<0)
		 	  {
  	 	   OSFreeTimer (USER_TIMER); 
		 	   OSRegisterTimer (USER_TIMER,abs(cmdsToPass[i])); // Prepare Timer for next loop
		 	   continue;
		 	  }
		 	 
		 	 y.x=cmdsToPass[i];
			 OSTimerRestart(USER_TIMER);  //Start Timer
		 	 while (!OSTimerExpired (USER_TIMER)) //wait 4/20 Seconds
		 	   {
		 	 	   idle(); //save battery
		 	   }
		 	 OSFreeTimer (USER_TIMER); 
		 	 OSRegisterTimer (USER_TIMER,6); // Prepare Timer for next loop
		  }

					
		//convert the number from 0x1234 to 0x3412 (reversing the bytes)
			t.c.c2=y.c.c1;
			t.c.c3=y.c.c0;

			
		//send the keypress
			OSWriteLinkBlock((char*)&t.x,4);
		

		
		 if (cmdCount==-1) // only interactive mode
      {
			//scroll if needed	(prepare to type a char)
				if(wpos>(2*lcdw)-4)	//-4 to avoid problems on the 92+
				{
					wpos=0;
					ScrRectScroll(&rect,&rect,9,A_REVERSE);
				}
				
			//print the typed char
				DrawChar(wpos,lcdh-15,t.c.c2,A_NORMAL);
				wpos+=7;
			}

		OSLinkClose();

		//exit if the ON key is pressed
			if(OSCheckBreak())
				{
				OSFreeTimer (USER_TIMER); // clean up timer		
				break;
				}
		}
		

}
